SYSTEM cellular_automaton;
CONST n = 512;          (* number of elements *)
      m = (n+1) DIV 2;  (* number of loops    *)

CONFIGURATION list [1..n];
CONNECTION left:  list[i] -> list[i-1] .right;
           right: list[i] -> list[i+1] .left;

SCALAR i,win  : INTEGER;
       ch     : CHAR;
VECTOR val,l,r: BOOLEAN;

BEGIN
  PARALLEL (* Init *)
    val := DIM1 = (n+1) DIV 2;  (* middle *)
  ENDPARALLEL;
  win  := OpenAbswindow(n, m); 
  SetColor(COLOR(0,0,0));  (* black *)

  FOR i:= 1 TO m DO
    PARALLEL
      IF val THEN SetPixel(DIM1, i) END;
      PROPAGATE.left (val,l);
      PROPAGATE.right(val,r);
      val := l<>r;
    ENDPARALLEL;
  END;

  WriteString("Press RETURN for termination"); WriteLn;
  Read(ch);
  CloseWindow(win);
END cellular_automaton.

